/*
Example for Led_Driver_2 Click

    Date          : avg 2017.
    Author        : MikroE Team

Test configuration DSPIC :
    
    MCU             : P33FJ256GP710A
    Dev. Board      : EasyPIC Fusion v7
    SW              : mikroC PRO for dsPIC v$${DSPIC_COMPILER_VER}

Description :

    ${EXAMPLE_DESCRIPTION}

*/

#include "stdint.h"

uint16_t dutyCycle;
uint16_t pwmPeriod;


void systemInit()
{
    CLKDIVbits.PLLPRE = 0;   // PLLPRE<4:0> = 0  ->  N1 = 2    8MHz / 2 = 4MHz
                             // (must be within 0.8 MHz to 8 MHz range)
    PLLFBD =   38;           // PLLDIV<8:0> = 38 ->  M = 40    4MHz * 40 = 160MHz
                             // (must be within 100 MHz to 200 MHz range)
    CLKDIVbits.PLLPOST = 0;  // PLLPOST<1:0> = 0 ->  N2 = 2    160MHz / 2 = 80MHz
                             // (must be within 12.5 MHz to 80 MHz range)

    AD1PCFGL = 0xFFFE;       // Set All pins as digital
    AD1PCFGH = 0xFFFF;
    dutyCycle = 0;
}

void Led_Driver_2_Init()
{
    pwmPeriod = PWM_Init(5000, 1, 1, 2);
    PWM_Start(1);
    PWM_Set_Duty(0, 1);
}

void Led_Driver_2_Task()
{
     dutyCycle += 50;
     PWM_Set_Duty(dutyCycle, 1);
     if (dutyCycle > pwmPeriod )
        dutyCycle = 0;
     Delay_ms(10);
}

void main()
{
    systemInit();
    Led_Driver_2_Init();

    while( 1 )
    {
            Led_Driver_2_Task();
    }
}